#pragma once
#include "gci.h"

//Functions
#define DCIHandleAlloc                 GCIHandleAlloc
#define DCIServerAttach                GCIServerAttach
#define DCIAttrSet                     GCIAttrSet
#define DCIAttrGet                     GCIAttrGet
#define DCISessionBegin                GCISessionBegin
#define DCISessionEnd                  GCISessionEnd
#define DCIStmtPrepare                 GCIStmtPrepare
#define DCIDefineByPos                 GCIDefineByPos
#define DCIDefineArrayOfStruct         GCIDefineArrayOfStruct
#define DCIStmtExecute                 GCIStmtExecute
#define DCIStmtFetch                   GCIStmtFetch
#define DCIHandleFree                  GCIHandleFree
#define DCIErrorGet                    GCIErrorGet
#define DCIBindByPos                   GCIBindByPos
#define DCIBindByName                  GCIBindByName
#define DCIBindArrayOfStruct           GCIBindArrayOfStruct
#define DCIParamGet                    GCIParamGet
#define DCIParamSet                    GCIParamSet
#define DCIEnvCreate                   GCIEnvCreate
#define DCIServerDetach                GCIServerDetach
#define DCIDescriptorAlloc             GCIDescriptorAlloc
#define DCIDescriptorFree              GCIDescriptorFree
#define DCIDescribeAny                 GCIDescribeAny
#define DCILogon                       GCILogon
#define DCILogoff                      GCILogoff
#define DCIServerVersion               GCIServerVersion
#define DCIServerSession               GCIServerSession
#define DCITransStart                  GCITransStart
#define DCITransCommit                 GCITransCommit
#define DCITransRollback               GCITransRollback
#define DCIInitialize                  GCIInitialize
#define DCIEnvInit                     GCIEnvInit
#define DCIDirPathColArrayReset        GCIDirPathColArrayReset
#define DCIDirPathStreamReset          GCIDirPathStreamReset
#define DCIDirPathColArrayEntrySet     GCIDirPathColArrayEntrySet
#define DCIDirPathColArrayToStream     GCIDirPathColArrayToStream
#define DCIDirPathLoadStream           GCIDirPathLoadStream
#define DCIDirPathDataSave             GCIDirPathDataSave
#define DCIDirPathFinish               GCIDirPathFinish
#define DCIDirPathPrepare              GCIDirPathPrepare
#define DCILobGetLength                GCILobGetLength
#define DCILobRead                     GCILobRead
#define DCICloseSvcSocket              GCICloseSvcSocket

#define DCIDateTimeGetTime             GCIDateTimeGetTime
#define DCIDateTimeGetDate             GCIDateTimeGetDate
#define DCIIntervalGetDaySecond        GCIIntervalGetDaySecond
#define DCIIntervalGetYearMonth        GCIIntervalGetYearMonth
#define DCINlsCharSetNameToId          GCINlsCharSetNameToId

//Handle Definitions
#define DCIError                       GCIError
#define DCIEnv                         GCIEnv
#define DCIServer                      GCIServer
#define DCISvcCtx                      GCISvcCtx
#define DCISession                     GCISession
#define DCITrans                       GCITrans
#define DCIStmt                        GCIStmt
#define DCIDefine                      GCIDefine
#define DCIBind                        GCIBind
#define DCIHIMP                        GCIHIMP
#define DCICPool                       GCICPool

//Error Return Values
#define DCI_SUCCESS                    GCI_SUCCESS
#define DCI_SUCCESS_WITH_INFO          GCI_SUCCESS_WITH_INFO
#define DCI_NEED_DATA                  GCI_NEED_DATA
#define DCI_NO_DATA                    GCI_NO_DATA
#define DCI_ERROR                      GCI_ERROR
#define DCI_INVALID_HANDLE             GCI_INVALID_HANDLE
#define DCI_STILL_EXECUTING            GCI_STILL_EXECUTING
#define DCI_CONTINUE                   GCI_CONTINUE

//Handle Types
#define DCI_HTYPE_ERROR                GCI_HTYPE_ERROR
#define DCI_HTYPE_SERVER               GCI_HTYPE_SERVER
#define DCI_HTYPE_SVCCTX               GCI_HTYPE_SVCCTX
#define DCI_HTYPE_SESSION              GCI_HTYPE_SESSION
#define DCI_HTYPE_TRANS                GCI_HTYPE_TRANS
#define DCI_HTYPE_STMT                 GCI_HTYPE_STMT
#define DCI_HTYPE_ENV                  GCI_HTYPE_ENV
#define DCI_HTYPE_DESCRIBE             GCI_HTYPE_DESCRIBE
#define DCI_HTYPE_AUTHINFO             GCI_HTYPE_AUTHINFO
#define DCI_HTYPE_BIND                 GCI_HTYPE_BIND
#define DCI_HTYPE_DEFINE               GCI_HTYPE_DEFINE
#define DCI_HTYPE_DIRPATH_CTX          GCI_HTYPE_DIRPATH_CTX
#define DCI_HTYPE_DIRPATH_COLUMN_ARRAY GCI_HTYPE_DIRPATH_COLUMN_ARRAY
#define DCI_HTYPE_DIRPATH_STREAM       GCI_HTYPE_DIRPATH_STREAM

//Various Modes
#define DCI_DEFAULT                    GCI_DEFAULT

//GCIInitialize Modes / GCICreateEnvironment Modes
#define DCI_THREADED                   GCI_THREADED
#define DCI_OBJECT                     GCI_OBJECT

//Execution Modes
#define DCI_BATCH_MODE                 GCI_BATCH_MODE
#define DCI_EXACT_FETCH                GCI_EXACT_FETCH
#define DCI_DESCRIBE_ONLY              GCI_DESCRIBE_ONLY
#define DCI_COMMIT_ON_SUCCESS          GCI_COMMIT_ON_SUCCESS
#define DCI_BATCH_ERRORS               GCI_BATCH_ERRORS
#define DCI_STMT_SCROLLABLE_READONLY   GCI_STMT_SCROLLABLE_READONLY

//Attribute Types
#define DCI_ATTR_SERVER                GCI_ATTR_SERVER
#define DCI_ATTR_USERNAME              GCI_ATTR_USERNAME
#define DCI_ATTR_PASSWORD              GCI_ATTR_PASSWORD
#define DCI_ATTR_STMT_TYPE             GCI_ATTR_STMT_TYPE
#define DCI_ATTR_ENV                   GCI_ATTR_ENV
#define DCI_CRED_RDBMS                 GCI_CRED_RDBMS
#define DCI_ATTR_SESSION               GCI_ATTR_SESSION
#define DCI_ATTR_TRANS                 GCI_ATTR_TRANS
#define DCI_ATTR_DATA_TYPE             GCI_ATTR_DATA_TYPE
#define DCI_ATTR_PARAM_COUNT           GCI_ATTR_PARAM_COUNT
#define DCI_ATTR_ROW_COUNT             GCI_ATTR_ROW_COUNT
#define DCI_ATTR_PARAM                 GCI_ATTR_PARAM
#define DCI_ATTR_LIST_COLUMNS          GCI_ATTR_LIST_COLUMNS
#define DCI_ATTR_NUM_COLS              GCI_ATTR_NUM_COLS
#define DCI_ATTR_PRECISION             GCI_ATTR_PRECISION
#define DCI_ATTR_SCALE                 GCI_ATTR_SCALE
#define DCI_ATTR_DATA_SIZE             GCI_ATTR_DATA_SIZE
#define DCI_ATTR_PREFETCH_ROWS         GCI_ATTR_PREFETCH_ROWS
#define DCI_ATTR_NUM_DML_ERRORS        GCI_ATTR_DML_ROW_OFFSET
#define DCI_ATTR_NAME                  GCI_ATTR_NAME
#define DCI_ATTR_ROWS_FETCHED          GCI_ATTR_ROWS_FETCHED
#define DCI_ATTR_NOCACHE               GCI_ATTR_NOCACHE
#define DCI_ATTR_BIND_COUNT            GCI_ATTR_BIND_COUNT
#define DCI_ATTR_ROWID                 GCI_ATTR_ROWID
#define DCI_ATTR_IS_NULL               GCI_ATTR_IS_NULL
#define DCI_ATTR_CONNECTION_CLASS      GCI_ATTR_CONNECTION_CLASS
#define DCI_ATTR_MODULE                GCI_ATTR_MODULE
#define DCI_ATTR_CURRENT_SCHEMA        GCI_ATTR_CURRENT_SCHEMA
#define DCI_ATTR_PURITY                GCI_ATTR_PURITY
#define DCI_ATTR_PURITY_NEW            GCI_ATTR_PURITY_NEW
#define DCI_ATTR_PURITY_DEFAULT        GCI_ATTR_PURITY_DEFAULT
#define DCI_ATTR_SCHEMA_NAME           GCI_ATTR_SCHEMA_NAME
#define DCI_ATTR_DATEFORMAT            GCI_ATTR_DATEFORMAT
#define DCI_ATTR_DIRPATH_INPUT         GCI_ATTR_DIRPATH_INPUT
#define DCI_ATTR_BUF_SIZE              GCI_ATTR_BUF_SIZE
#define DCI_ATTR_NUM_ROWS              GCI_ATTR_NUM_ROWS

/* ------------------------------------------------------------------------- */
//Parsing Syntax Types
#define DCI_NTV_SYNTAX                 GCI_NTV_SYNTAX

//(Scrollable Cursor) Fetch Options
#define DCI_FETCH_CURRENT              GCI_FETCH_CURRENT
#define DCI_FETCH_NEXT                 GCI_FETCH_NEXT
#define DCI_FETCH_FIRST                GCI_FETCH_FIRST
#define DCI_FETCH_LAST                 GCI_FETCH_LAST
#define DCI_FETCH_PRIOR                GCI_FETCH_PRIOR
#define DCI_FETCH_ABSOLUTE             GCI_FETCH_ABSOLUTE
#define DCI_FETCH_RELATIVE             GCI_FETCH_RELATIVE
#define DCI_FETCH_RESERVED_1           GCI_FETCH_RESERVED_1
#define DCI_FETCH_RESERVED_2           GCI_FETCH_RESERVED_2
#define DCI_FETCH_RESERVED_3           GCI_FETCH_RESERVED_3
#define DCI_FETCH_RESERVED_4           GCI_FETCH_RESERVED_4
#define DCI_FETCH_RESERVED_5           GCI_FETCH_RESERVED_5

//Descriptor Types
#define DCI_DTYPE_LOB                  GCI_DTYPE_LOB
#define DCI_DTYPE_FILE                 GCI_DTYPE_FILE
#define DCI_DTYPE_PARAM                GCI_DTYPE_PARAM
#define DCI_DTYPE_TIMESTAMP            GCI_DTYPE_TIMESTAMP
#define DCI_DTYPE_TIMESTAMP_TZ         GCI_DTYPE_TIMESTAMP_TZ
#define DCI_DTYPE_TIMESTAMP_LTZ        GCI_DTYPE_TIMESTAMP_LTZ
#define DCI_DTYPE_INTERVAL_DS          GCI_DTYPE_INTERVAL_DS

//GCI Parameter Types
#define DCI_PTYPE_TABLE                GCI_PTYPE_TABLE
#define DCI_PTYPE_PROC                 GCI_PTYPE_PROC
#define DCI_PTYPE_FUNC                 GCI_PTYPE_FUNC
#define DCI_PTYPE_PKG                  GCI_PTYPE_PKG

//Descriptor Definitions
#define DCIParam                       GCIParam
#define DCILobLocator                  GCILobLocator
#define DCIDateTime                    GCIDateTime
#define DCIInterval                    GCIInterval
#define DCISnapshot                    GCISnapshot
#define DCIDescribe                    GCIDescribe
#define DCIDate                        GCIDate

#define  DCIDateYYYY                   GCIDateYYYY
#define  DCIDateMM                     GCIDateMM
#define  DCIDateDD                     GCIDateDD
#define DCITimeHH                      GCITimeHH
#define DCITimeMI                      GCITimeMI
#define DCITimeSS                      GCITimeSS
#define DCIDateTime                    GCIDateTime

//Piece Definitions
#define DCI_ONE_PIECE                  GCI_ONE_PIECE
#define DCI_FIRST_PIECE                GCI_FIRST_PIECE
#define DCI_LAST_PIECE                 GCI_LAST_PIECE
#define DCI_NEXT_PIECE                 GCI_NEXT_PIECE

//Object Ptr Types
#define DCI_OTYPE_NAME                 GCI_OTYPE_NAME

#define DCI_ATTR_LIST_ARGUMENTS        GCI_ATTR_LIST_ARGUMENTS
#define DCI_ATTR_LIST_SUBPROGRAMS      GCI_ATTR_LIST_SUBPROGRAMS
#define DCI_ATTR_NUM_PARAMS            GCI_ATTR_NUM_PARAMS
#define DCI_ATTR_PTYPE                 GCI_ATTR_PTYPE

#define DCI_NUMBER_SIZE                GCI_NUMBER_SIZE
/*--------------------------- GCI Statement Types ---------------------------*/
#define  DCI_STMT_UNKNOWN              GCI_STMT_UNKNOWN
#define  DCI_STMT_SELECT               GCI_STMT_SELECT
#define  DCI_STMT_UPDATE               GCI_STMT_UPDATE
#define  DCI_STMT_DELETE               GCI_STMT_DELETE
#define  DCI_STMT_INSERT               GCI_STMT_INSERT
#define  DCI_STMT_CREATE               GCI_STMT_CREATE
#define  DCI_STMT_DROP                 GCI_STMT_DROP
#define  DCI_STMT_ALTER                GCI_STMT_ALTER
#define  DCI_STMT_BEGIN                GCI_STMT_BEGIN
#define  DCI_STMT_DECLARE              GCI_STMT_DECLARE
#define  DCI_STMT_CALL                 GCI_STMT_CALL
/*---------------------------------------------------------------------------*/

/*--------------------------- GCI Parameter Types ---------------------------*/
#define DCI_PTYPE_UNK                  GCI_PTYPE_UNK
#define DCI_PTYPE_TABLE                GCI_PTYPE_TABLE
#define DCI_PTYPE_VIEW                 GCI_PTYPE_VIEW
#define DCI_PTYPE_PROC                 GCI_PTYPE_PROC
#define DCI_PTYPE_FUNC                 GCI_PTYPE_FUNC
#define DCI_PTYPE_PKG                  GCI_PTYPE_PKG
#define DCI_PTYPE_TYPE                 GCI_PTYPE_TYPE
#define DCI_PTYPE_SYN                  GCI_PTYPE_SYN
#define DCI_PTYPE_SEQ                  GCI_PTYPE_SEQ
#define DCI_PTYPE_COL                  GCI_PTYPE_COL
#define DCI_PTYPE_ARG                  GCI_PTYPE_ARG
#define DCI_PTYPE_LIST                 GCI_PTYPE_LIST
#define DCI_PTYPE_TYPE_ATTR            GCI_PTYPE_TYPE_ATTR
#define DCI_PTYPE_TYPE_COLL            GCI_PTYPE_TYPE_COLL
#define DCI_PTYPE_TYPE_METHOD          GCI_PTYPE_TYPE_METHOD
#define DCI_PTYPE_TYPE_ARG             GCI_PTYPE_TYPE_ARG
#define DCI_PTYPE_TYPE_RESULT          GCI_PTYPE_TYPE_RESULT
#define DCI_PTYPE_SCHEMA               GCI_PTYPE_SCHEMA
#define DCI_PTYPE_DATABASE             GCI_PTYPE_DATABASE
#define DCI_PTYPE_RULE                 GCI_PTYPE_RULE
#define DCI_PTYPE_RULE_SET             GCI_PTYPE_RULE_SET
#define DCI_PTYPE_EVALUATION_CONTEXT   GCI_PTYPE_EVALUATION_CONTEXT
#define DCI_PTYPE_TABLE_ALIAS          GCI_PTYPE_TABLE_ALIAS
#define DCI_PTYPE_VARIABLE_TYPE        GCI_PTYPE_VARIABLE_TYPE
#define DCI_PTYPE_NAME_VALUE           GCI_PTYPE_NAME_VALUE

/*---------------------------------------------------------------------------*/

/*------------------------ Transaction Start Flags --------------------------*/
#define DCI_TRANS_NEW                  GCI_TRANS_NEW
#define DCI_TRANS_JOIN                 GCI_TRANS_JOIN
#define DCI_TRANS_RESUME               GCI_TRANS_RESUME
#define DCI_TRANS_STARTMASK            GCI_TRANS_STARTMASK

#define DCI_TRANS_READONLY             GCI_TRANS_READONLY
#define DCI_TRANS_READWRITE            GCI_TRANS_READWRITE
#define DCI_TRANS_SERIALIZABLE         GCI_TRANS_SERIALIZABLE
/* starts a serializable transaction */
#define DCI_TRANS_ISOLMASK             GCI_TRANS_ISOLMASK

#define DCI_TRANS_LOOSE                GCI_TRANS_LOOSE
#define DCI_TRANS_TIGHT                GCI_TRANS_TIGHT
#define DCI_TRANS_TYPEMASK             GCI_TRANS_TYPEMASK

#define DCI_TRANS_NOMIGRATE            GCI_TRANS_NOMIGRATE
#define DCI_TRANS_SEPARABLE            GCI_TRANS_SEPARABLE
#define DCI_TRANS_OTSRESUME            GCI_TRANS_OTSRESUME


/*---------------------------------------------------------------------------*/

/*------------------------ Transaction End Flags ----------------------------*/
#define DCI_TRANS_TWOPHASE             GCI_TRANS_TWOPHASE
#define DCI_TRANS_WRITEBATCH           GCI_TRANS_WRITEBATCH
#define DCI_TRANS_WRITEIMMED           GCI_TRANS_WRITEIMMED
#define DCI_TRANS_WRITEWAIT            GCI_TRANS_WRITEWAIT
#define DCI_TRANS_WRITENOWAIT          GCI_TRANS_WRITENOWAIT
/*---------------------------------------------------------------------------*/

#define DCI_ATTR_CHAR_USED             GCI_ATTR_CHAR_USED
#define DCI_ATTR_CHAR_SIZE             GCI_ATTR_CHAR_SIZE
/*---------------------------------------------------------------------------*/

#define DCItext                        GCItext
#define DciText                        GCItext


/*-----------------------DirPath Type---------------------------------------*/

#define DCIDirPathCtx                  GCIDirPathCtx
#define DCIDirPathColArray             GCIDirPathColArray
#define DCIDirPathStream               GCIDirPathStream
#define DCI_DIRPATH_COL_NULL           GCI_DIRPATH_COL_NULL
#define DCI_DIRPATH_COL_COMPLETE       GCI_DIRPATH_COL_COMPLETE
#define DCI_DIRPATH_DATASAVE_FINISH    GCI_DIRPATH_DATASAVE_FINISH
#define DCI_DIRPATH_INPUT_STREAM       GCI_DIRPATH_INPUT_STREAM

